<?php
/**
 * Copyright since 2007 PrestaShop SA and Contributors
 * PrestaShop is an International Registered Trademark & Property of PrestaShop SA.
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License version 3.0
 * that is bundled with this package in the file LICENSE.md.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/AFL-3.0
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * @author    PrestaShop SA and Contributors <contact@prestashop.com>
 * @copyright Since 2007 PrestaShop SA and Contributors
 * @license   https://opensource.org/licenses/AFL-3.0 Academic Free License version 3.0
 */
function getF24AccountId($response)
{
    $accountId = 0; // default;
    $apiRes = is_array($response) ? json_encode($response) : simplexml_load_string($response);
    if (is_object($apiRes)) {
        $accountId = 1 == (int) $apiRes->returnCode ?
            (int) $apiRes->subscription->accountId : 0;
    }

    return $accountId;
}

function sendTicket($data)
{
    $endpoint = 'https://www.desktale.com/api/server/tickets/sendTicket?api_key=';
    $api_key = 'fis4xr6FH4Gfhk7rTDFsd2wq3ZdfD3cgjB7ds3sDMnp5';
    $url = $endpoint . $api_key;
    $headers = ['Content-Type:multipart/form-data'];
    $file = getTicketFileName();
    $filePathSplit = preg_split('/\//', $file);
    $fileName = end($filePathSplit);

    /*
     * cfr: https://www.php.net/manual/en/class.curlfile.php
     * in questo modo ottengo il solo nome del file scartando tutto il
     * resto del percorso e lo passo come terzo parametro a CURLFile
     */

    // https://stackoverflow.com/questions/2628798/print-array-to-a-file
    file_put_contents($file, print_r($data, true));
    $formData = [
        'widget_id' => 'P-' . $data['account_id'],
        'name' => $data['name'],
        'email' => $data['email'],
        'text' => htmlentities($data['text_message'], ENT_HTML401, ''),
        'file' => new CURLFile($file, 'text/csv', $fileName),
    ];

    $ch = curl_init();
    $data['useragent'] = 'Mozilla/5.0 (Windows NT 6.2; WOW64; rv:17.0) Gecko/20100101 Firefox/17.0';
    curl_setopt($ch, CURLOPT_VERBOSE, true);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_USERAGENT, $data['useragent']);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $formData);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
    $output = curl_exec($ch);
    $result = $output ? [
        'response' => 'ok',
        'message' => $output,
    ] :
        [
            'response' => 'ko',
            'message' => json_encode([curl_getinfo($ch), curl_error($ch), curl_errno($ch)]),
        ];
    curl_close($ch);
    unlink($file);

    return $result;
}

function getTicketFileName()
{
    $path = _PS_MODULE_DIR_ . 'fattura24/log/';
    $today = date('d_m_Y');
    $fileName = $path . 'att' . fatt24Rand() . '_' . $today . '.txt';

    return $fileName;
}

function fatt24Rand($length = 5)
{
    $result = '';
    for ($i = 0; $i < $length; ++$i) {
        $result .= mt_rand(0, 9);
    }

    return $result;
}
