/**
 * Copyright since 2007 PrestaShop SA and Contributors
 * PrestaShop is an International Registered Trademark & Property of PrestaShop SA
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License version 3.0
 * that is bundled with this package in the file LICENSE.md.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/AFL-3.0
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * @author    PrestaShop SA and Contributors <contact@prestashop.com>
 * @copyright Since 2007 PrestaShop SA and Contributors
 * @license   https://opensource.org/licenses/AFL-3.0 Academic Free License version 3.0
 */ 

window.addEventListener('load', () => {
    let wrapper = document.getElementById('fattura24_wrapper');
    let settings = document.getElementById('fattura24_settings');
    let support = document.getElementById('fattura24_support');
    

    settings.classList.add('active'); // initial value
        
    settings.addEventListener('click', function(e){
        let blocks = {
            toShow: 'show_settings',
            toHide: 'show_support' ,
        };
        settings.classList.add('active');
        support.classList.remove('active');
        toggleShowHide(blocks);
    });
    
    support.addEventListener('click', function(e){
        let blocks = {
            toShow: 'show_support',
            toHide: 'show_settings',
        };
        settings.classList.remove('active');
        support.classList.add('active');
        toggleShowHide(blocks);
    });
    
    function toggleShowHide(blocks) {
        let blockToHide = document.getElementById(blocks.toHide);
        let blockToShow = document.getElementById(blocks.toShow);
        wrapper.style.display = blocks.toShow === 'show_settings' ? 'inline-block' : 'none';
        blockToShow.style.display = 'inline-block';
        blockToHide.style.display = 'none';
    } 
});
