/**
 * Copyright since 2007 PrestaShop SA and Contributors
 * PrestaShop is an International Registered Trademark & Property of PrestaShop SA
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License version 3.0
 * that is bundled with this package in the file LICENSE.md.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/AFL-3.0
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * @author    PrestaShop SA and Contributors <contact@prestashop.com>
 * @copyright Since 2007 PrestaShop SA and Contributors
 * @license   https://opensource.org/licenses/AFL-3.0 Academic Free License version 3.0
 */ 

function toggle(element, status){
    if(status === 'disabled'){
        $(element).prop('checked', false)
        $(element).prop('disabled', true)
    } else if(status === 'readonly'){
        $(element).prop('disabled', true)
    } else {
        $(element).prop('disabled', false)
    }
    var panels = document.getElementsByClassName('panel');
    var panel = panels[0];
}    

window.addEventListener('load', () => {

    let btn = document.getElementById("verify");

    btn.addEventListener('click', function (e) {
            let source = document.getElementById('source').innerHTML;
            let apiKey = PS_FATTURA24_API.value;
            let xhr = new XMLHttpRequest();
            let params = "apiKey=" + apiKey + "&source=" + source;
            let today = new Date();
          
            xhr.open("post", "https://www.app.fattura24.com/api/v0.3/TestKey", true);
            xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
            xhr.send(params);
            xhr.onload = function () {
                //console.log(this.responseText);
                let response = this.responseText.replace("&egrave;", ""); //devo togliere questa parte altrimenti da problemi con l'encoding xml
                console.log(response);
                let parser = new DOMParser();
                let xml = parser.parseFromString(response, "text/xml");
                let code = xml.getElementsByTagName('returnCode');
  
                let description = xml.getElementsByTagName('description');
                let type = xml.getElementsByTagName('type'); // tipo di abbonamento
                let expire = xml.getElementsByTagName('expire'); // data di scadenza
                let year = expire[0].childNodes[0].nodeValue.slice(6, 10);
                // tolgo 1 perché in Js il primo mese è zero
                let month = expire[0].childNodes[0].nodeValue.slice(3, 5) - 1;
                let day = expire[0].childNodes[0].nodeValue.slice(0, 2);
                let expireDate = new Date(year, month, day);
                let diff = expireDate.getTime() - today.getTime();
                let diffInDays = Math.ceil(diff / (1000 * 3600 * 24));
                let expiryMessage = '';
                if (diffInDays < 30) {
                    expiryMessage = "<br/><span style='color: red;'>Mancano " +  diffInDays + " giorni alla scadenza!</span> <a href='https://www.fattura24.com/' target='_blank'> Rinnova ora </a>"; 
                }   



                let totalCallInLast24Hour = xml.getElementsByTagName('totalCallInLast24Hour'); // totale chiamate API nelle ultime 24h
                
                if (code[0].childNodes[0].nodeValue == 1) {
                    try {  
                        document.getElementById("result").innerHTML = "<span style='color: green; font-size: 120%;'>API Key verificata!</span><br/>"; 
                        document.getElementById("expire").innerHTML = "<span style='color: green; font-size: 120%;'>" + expire[0].childNodes[0].nodeValue + "</span>"
                        + expiryMessage +
                         "<br /><span style='font-size: 120%;'> Totale chiamate API nelle ultime 24h : " + totalCallInLast24Hour[0].childNodes[0].nodeValue;
                    } catch (e) {
                        document.getElementById("result").innerHTML = "<span style='color: red; font-size: 120%;'>Test account!</span></br>";
                    }                 

                } else if(!apiKey) {
                     document.getElementById("result").innerHTML = "<span style='color: red; font-size: 120%;'>API Key non inserita </span></br>"; 
                               
				} else {	
                   
                    try {
						if (type[0].childNodes[0].nodeValue < 5) { 
						    document.getElementById("expire").innerHTML = "<span style='color: red; font-size: 120%;'>{l s='To use this service you need a Business or Enterprise subscription!' mod='fattura24'} </span></br>";
						}
					} catch (e) {
						document.getElementById("result").innerHTML = "<span style='color: red; font-size: 120%;'>{l s='API Key not valid!' mod='fattura24'} </span></br>";
					}	
                                      
                }
            }
        
        }); // end of button event listener

        // default Object
        let Objectbtn = document.getElementById("F24Object");

        Objectbtn.addEventListener('click', function (e) {
            document.getElementById("PS_INV_OBJECT").defaultValue = "Ordine (N) Shop on-line";
        });  

        // Rubrica
        const PS_SALVA_CLIENTE = document.getElementById('PS_SALVA_CLIENTE_');

        // Ordini
        const PS_CREA_ORDINE = document.getElementById('PS_CREA_ORDINE_');
        const PS_ABILITA_ORDINE_ZERO = document.getElementById('PS_ABILITA_ORDINE_ZERO');
        const PS_PDF_ORDINE = document.getElementById('PS_PDF_ORDINE_');
        const PS_MAIL_ORDINE = document.getElementById('PS_MAIL_ORDINE_');
        const PS_F24_MAGAZZINO_ORDINE = document.getElementById('PS_F24_MAGAZZINO_ORDINE_');
        const PS_F24_MODELLO_ORDINE = document.getElementById('PS_F24_MODELLO_ORDINE_');
        const PS_F24_MODELLO_ORDINE_DEST = document.getElementById('PS_F24_MODELLO_ORDINE_DEST_');
        

        if (!PS_CREA_ORDINE.checked){
            toggle(PS_ABILITA_ORDINE_ZERO, 'disabled');
            toggle(PS_PDF_ORDINE, 'disabled');
            toggle(PS_MAIL_ORDINE, 'disabled');
            toggle(PS_F24_MAGAZZINO_ORDINE, 'disabled');
            toggle(PS_F24_MODELLO_ORDINE, 'disabled');
            toggle(PS_F24_MODELLO_ORDINE_DEST, 'disabled');
        }
        if (PS_CREA_ORDINE.checked){
            PS_SALVA_CLIENTE.checked = true;
            PS_SALVA_CLIENTE.disabled = true;
        }

          // Listener per creazione ordine
        PS_CREA_ORDINE.addEventListener('change', function (e){
            if (PS_CREA_ORDINE.checked){
                toggle(PS_ABILITA_ORDINE_ZERO);
                toggle(PS_PDF_ORDINE);
                toggle(PS_MAIL_ORDINE);
                toggle(PS_F24_MAGAZZINO_ORDINE);
                toggle(PS_F24_MODELLO_ORDINE);
                toggle(PS_F24_MODELLO_ORDINE_DEST);
                PS_SALVA_CLIENTE.checked = true;
                PS_SALVA_CLIENTE.disabled = true;
            }
            else{
                toggle(PS_ABILITA_ORDINE_ZERO, 'disabled');
                toggle(PS_PDF_ORDINE, 'disabled');
                toggle(PS_MAIL_ORDINE, 'disabled');
                toggle(PS_F24_MAGAZZINO_ORDINE, 'disabled');
                toggle(PS_F24_MODELLO_ORDINE, 'disabled');
                toggle(PS_F24_MODELLO_ORDINE_DEST, 'disabled');
                if(!PS_CREAZIONE_FATTURA.checked)
                    PS_SALVA_CLIENTE.disabled = false;
            }          
        });

        const PS_CREAZIONE_FATTURA = document.getElementById('PS_CREAZIONE_FATTURA_');
        const PS_ABILITA_FATTURA_ZERO = document.getElementById('PS_ABILITA_FATTURA_ZERO');
        const PS_DISABILITA_RICEVUTE = document.getElementById('PS_DISABILITA_RICEVUTE_');
        const PS_EMAIL_FATTURA = document.getElementById('PS_EMAIL_FATTURA_');
        const PS_STATO_PAGATO = document.getElementById('PS_STATO_PAGATO_');

        const PS_INV_OBJECT = document.getElementById('PS_INV_OBJECT');       
        const PS_CONF_NATURA_IVA = document.getElementById('PS_CONF_NATURA_IVA');
        const PS_CONF_NATURA_SPEDIZIONE = document.getElementById('PS_CONF_NATURA_SPEDIZIONE');
        const PS_F24_MAGAZZINO_FATTURA = document.getElementById('PS_F24_MAGAZZINO_FATTURA_');
        const PS_F24_MODELLO_FATTURA = document.getElementById('PS_F24_MODELLO_FATTURA_');
        
        const PS_F24_MODELLO_FATTURA_DEST = document.getElementById('PS_F24_MODELLO_FATTURA_DEST_');
        const PS_F24_PDC = document.getElementById('PS_F24_PDC_');
        
        const PS_F24_SEZIONALE_RICEVUTA = document.getElementById('PS_F24_SEZIONALE_RICEVUTA_');
        const PS_F24_SEZIONALE_FATTURA = document.getElementById('PS_F24_SEZIONALE_FATTURA_');
        const PS_F24_BOLLO_VIRTUALE = document.getElementById('PS_F24_BOLLO_VIRTUALE_FE');
        
        // Listener per creazione fatture
        PS_CREAZIONE_FATTURA.addEventListener('change', function (e){
            let valueSelected = PS_CREAZIONE_FATTURA.options[PS_CREAZIONE_FATTURA.selectedIndex].text;
            //console.log("SELECTED OPTION FATTURA = "+ valueSelected);
            
            switch (valueSelected) {
                case 'Disabilitato':
                    toggle(PS_DISABILITA_RICEVUTE, 'disabled');
                    toggle(PS_ABILITA_FATTURA_ZERO, 'disabled');
                    toggle(PS_EMAIL_FATTURA, 'disabled');
                    toggle(PS_STATO_PAGATO, 'disabled');
                    toggle(PS_F24_MAGAZZINO_FATTURA, 'disabled');
                    toggle(PS_F24_MODELLO_FATTURA, 'disabled');
                    toggle(PS_F24_MODELLO_FATTURA_DEST, 'disabled');
                    toggle(PS_F24_PDC, 'disabled');
                    toggle(PS_F24_SEZIONALE_RICEVUTA, 'disabled');
                    toggle(PS_F24_SEZIONALE_FATTURA, 'disabled');
                    toggle(PS_INV_OBJECT, 'disabled');
                    toggle(PS_CONF_NATURA_IVA, 'readonly');
                    toggle(PS_CONF_NATURA_SPEDIZIONE, 'readonly');
                    toggle(PS_F24_BOLLO_VIRTUALE, 'readonly');
                    break;
                case 'Fattura NON elettronica':
                case 'Ricevuta NON elettronica':
                    PS_SALVA_CLIENTE.checked = true;
                    PS_SALVA_CLIENTE.disabled = true;
                    toggle(PS_ABILITA_FATTURA_ZERO, 'enabled');
                    toggle(PS_F24_PDC, 'enabled');
                    toggle(PS_DISABILITA_RICEVUTE, 'enabled');
                    toggle(PS_EMAIL_FATTURA, 'enabled');
                    toggle(PS_INV_OBJECT, 'enabled');
                    toggle(PS_STATO_PAGATO, 'enabled');
                    toggle(PS_CONF_NATURA_IVA, 'readonly');
                    toggle(PS_CONF_NATURA_SPEDIZIONE, 'readonly');
                    toggle(PS_F24_BOLLO_VIRTUALE, 'readonly');
                    toggle(PS_F24_MODELLO_FATTURA, 'enabled');
                    toggle(PS_F24_MODELLO_FATTURA_DEST, 'enabled');
                    toggle(PS_F24_SEZIONALE_RICEVUTA, 'enabled');
                    toggle(PS_F24_SEZIONALE_FATTURA, 'enabled');
                    break;
                case 'Fattura elettronica':
                    toggle(PS_ABILITA_FATTURA_ZERO, 'enabled');
                    toggle(PS_F24_PDC, 'enabled');
                    toggle(PS_DISABILITA_RICEVUTE, 'enabled');
                    toggle(PS_EMAIL_FATTURA, 'enabled');
                    toggle(PS_INV_OBJECT, 'enabled');
                    toggle(PS_STATO_PAGATO, 'enabled');
                    toggle(PS_CONF_NATURA_IVA, 'enabled');
                    toggle(PS_CONF_NATURA_SPEDIZIONE, 'enabled');
                    toggle(PS_F24_BOLLO_VIRTUALE, 'enabled');
                    toggle(PS_F24_SEZIONALE_RICEVUTA, 'enabled');
                    toggle(PS_F24_SEZIONALE_FATTURA, 'enabled');
                    toggle(PS_F24_MODELLO_FATTURA, 'enabled');
                    toggle(PS_F24_MODELLO_FATTURA_DEST, 'enabled');
                    break;
                default:
                    toggle(PS_ABILITA_FATTURA_ZERO, 'enabled');
                    toggle(PS_INV_OBJECT, 'enabled');
                    toggle(PS_STATO_PAGATO, 'enabled');
                    toggle(PS_CONF_NATURA_IVA, 'readonly');
                    toggle(PS_CONF_NATURA_SPEDIZIONE, 'readonly');
                    toggle(PS_F24_SEZIONALE_RICEVUTA, 'enabled');
                    toggle(PS_F24_SEZIONALE_FATTURA, 'enabled');
                    toggle(PS_F24_BOLLO_VIRTUALE, 'readonly');
                    break;                
            }
        });
});